; routine to cycle through the fields
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
        include win1_inc_keys_ext_thg
*
; cycle through the fields
; needs a seed fieldid (should have thp..ret set), the first field with an id higher than seed will be returned
; will be updated to give fieldid of the fieldname which is returned
; you can also get the fieldtype as well
; fieldname is max 16 chars long and that amount of space has to be available in the return string !!
; it is impossible to find out about fieldid 0 with this routine, but fieldid 0 IS always the MEMO field
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.seed  equ     $c      ; seed fieldid (uword, can be updated)
p.type  equ     $14     ; field type (key, uword, can be updated)
p.ret   equ     $1c     ; return fieldname (string or substring (C-string))
; errors
; itnf  buffer id invalid
; orng  hey a fieldid can't be higher than 255
; eof   hey, there are no fields left (seed updated to 0)
cod_CYCF xsub
        regsave d1/d2/a1-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        move.l  b_file(a4),a4   ; we only need fileid

        ; check whether field is in range
        move.l  p.seed(a5),a1   ; ptr to seed
        move.l  p.type(a5),a2   ; ptr to type
        move.l  p.ret(a5),a3    ; ptr to string to fill in
        moveq   #err.orng,d0    ; assume out of range
        move.w  (a1),d1         ; seed fieldid
        bmi.s   codend          ; wel it sure can't be negative !!
        cmpi.w  #256,d1         ; test whether in range
        bpl.s   codend          ; no it isn't

        ; now find the next field
        move.w  d1,d2           ; we keep the current fieldid in d1
        mulu    #18,d2          ; and the place in fielddata in d2
        add.w   #f_fields,d2    ; offset in filedata
        lea     0(a4,d2.w),a4   ; start of this fields data
next    addq.w  #1,d1           ; let's test the next field
        adda.w  #18,a4          ; also the next object in the offset
        moveq   #err.eof,d0     ; assume we have reached the last one
        cmpi.w  #256,d1         ; test whether in range
        bmi.s   cont            ; it is -> continue
        move.w  p.seed-4(a5),d0 ; not in range, update seed to 0 if asked
        btst    #thp..ret,d0    ; do we have to update this ?
        beq.s   codend          ; no -> don't
        move.w  #0,(a1)         ; update seed to start of cycle
        bra.s   codend          ; terminate
cont
        tst.w   (a4)            ; is this field in use ?
        beq.s   next            ; no -> try the next one

        ; return the fieldid (d1) if thp..ret set
        move.w  p.seed-4(a5),d0
        btst    #thp..ret,d0    ; do we have to return this ?
        beq.s   nretid          ; no -> don't
        move.w  d1,(a1)         ; update seed
nretid
        ; return the fieldtype if thp..ret set
        moveq   #0,d1
        move.b  (a4)+,d1        ; get the fieldtype
        move.w  p.type-4(a5),d0
        btst    #thp..ret,d0    ; do we have to return this ?
        beq.s   nrettp          ; no -> don't
        move.w  d1,(a2)         ; update type
nrettp
        ; now return the fieldname
        move.w  p.ret-4(a5),d2  ; type of ret param
        moveq   #0,d0
        move.b  (a4)+,d0        ; fieldname length
        move.l  p.ret(a5),a1    ; place to fill in return value
        btst    #thp..sst,d2    ; sub-string ??
        bne.s   sstr
        move.w  d0,(a1)+        ; fill in fieldnamelen
sstr    subq.w  #1,d0           ; adjust to dbf
lp      move.b  (a4)+,(a1)+     ; copy 'another' char
        dbf     d0,lp
        btst    #thp..sst,d2    ; sub-string ??
        beq.s   done
        clr.b   (a1)+           ; end of string marker
done    moveq   #0,d0           ; no error
codend
        subend
;
        end
