; FiND a String/Integer/Double
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
        include win1_inc_keys_ext_thg
*
; FiND a String (Integer/Double)
; searches in a field if fieldid given, else it searches all fields (of suitable type)
; returns (if asked) the fieldid and place where found
; compare : again (search from next/prev record, not start/end), case, reverse
; the first/last, next/prev commands are used for navigation, so default index is important
; parameters
p.id    equ     $4      ; buffer id or indexid (long word, optional)
p.fld   equ     $8      ; fieldid (optional, default is search all fields)
p.cmp   equ     $c      ; compare method
p.str   equ     $14     ; ptr to string or substring to find
p.rfld  equ     $1c     ; field where found (update word)
p.rplc  equ     $24     ; place in field where found (update uword)
; errors :
; itnf  invalid buffer or indexid
;       not found
; ipar  invalid fieldid given (wrong type or doesn't exist), or no string to search given
; any error returned by FRST/LAST/NEXT/PREV
cod_FNDS xsub
        regsave d1/d3/a0/a3/a5
        move.l  a1,a5
        move.l  #ft.text<<16+ft.text,d5
        ; now read the searched string
        moveq   #err.ipar,d0    ; assume problems
        move.w  p.str-4(a5),d1  ; type of parameter
        beq.s   s_end           ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.str(a5),a3    ; ptr to name
        move.w  (a3)+,d3        ; string length
        beq.s   s_end           ; if zero -> no field to include
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   s_end
        move.w  p.str-2(a5),d3  ; string length
        beq.s   s_end           ; if zero -> no field to include
        move.l  p.str(a5),a3    ; ptr to name
codcps  lea     str(pc),a0
        bsr.s   find
s_end   subend
*
; FiND an Integer
; see FNDS
;p.id    equ     $4      ; buffer id or indexid (long word, optional)
;p.fld   equ     $8      ; fieldid (optional, default is search all fields)
;p.cmp   equ     $c      ; compare method
p.int   equ     $10     ; integer to find
p.unus  equ     $14     ; unused (.l)
;p.rfld  equ     $1c     ; field where found (update word)
;p.rplc  equ     $24     ; place in field where found (update uword)
; errors : see FNDS
cod_FNDI xsub
        regsave d1/d5/a0/a5
        move.l  a1,a5
        move.l  #ft.long<<16+ft.long,d5
        move.l  p.int(a5),d1    ; see if value fits in a word
        bpl.s   posint          ; is pos
        neg.l   d1              ; make pos
posint  swap    d1              ; take high word
        tst.w   d1              ; test it
        bne.s   fint            ; oops, only long words
        move.w  #ft.short,d5    ; test short also
fint    lea     int(pc),a0
        bsr.s   find
        subend
*
; FiND a Double
; see FNDS
;p.id    equ     $4      ; buffer id or indexid (long word, optional)
;p.fld   equ     $8      ; fieldid (optional, default is search all fields)
;p.cmp   equ     $c      ; compare method
p.dbl   equ     $10     ; double to find
;p.rfld  equ     $1c     ; field where found (update word)
;p.rplc  equ     $24     ; place in field where found (update uword)
; errors : see FNDS
cod_FNDD xsub
        regsave d5/a0/a5
        move.l  a1,a5
        move.l  #ft.ieee<<16+ft.ieee,d5
        lea     dbl(pc),a0
        bsr.s   find
        subend

;
; routine for find xxx
; needs, parameterblock in a5, routine for search field in a0 (this routine just gets the field in a1)
; preserved for the search routine are d3/a3, routine also get fieldtype in d4
; also needs suitable fieldtypes (d5 high and low, to allow two fieldid's)
; register usage : d6 place in field, d7 fieldid of field tried (also for search)
find    subr
        regsave d1/d2/d4-d7/a1/a2/a4
        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        moveq   #0,d7
        move.w  p.fld+2(a5),d7  ; fieldid to search
        bmi.s   start           ; not passed -> don't test fieldtype
        moveq   #err.ipar,d0    ; assume fieldid not valid
        cmpi.w  #255,d7         ; in range ??
        bgt     codend          ; oops
        mulu    #18,d7          ; offset in list
        addi.w  #f_fields,d7    ; offset in fielddata
        move.l  b_file(a4),a1   ; filedata
        move.b  0(a1,d7.w),d4   ; fieldtype
        cmp.b   d4,d5           ; fieldid ok ??
        beq.s   start           ; yes -> ..
        swap    d5
        cmp.b   d4,d5           ; other possible value
        bne     codend          ; no, wrong type -> ...

start   move.w  p.cmp+2(a5),d1  ; again ??
        btst    #c..agai,d1
        bne.s   nextrec         ; yes -> start with "next" record
        move.l  a5,a1           ; parameter block
        move.w  p.cmp+2(a5),d1  ; reverse ?? (we have to get "first" record)
        btst    #c..rvrs,d1
        beq.s   first
        xjsr    cod_LAST        ; start with last record
        bne.s   codend
        bra.s   loop
first   xjsr    cod_FRST        ; start with first record
        bne.s   codend

loop    move.w  p.fld+2(a5),d7  ; fieldid to search
        bmi.s   allfld          ; not passed -> search all field

        move.w  d7,d2           ; fieldid
        move.l  b_rlen(a4),d1   ; reclen
        move.l  b_mem(a4),a1    ; start of record-buffer
        xjsr    findfld
        bne.s   nextrec         ; not found -> try next record
        jsr     (a0)            ; find value in field
        beq.s   setret          ; found -> return correct values

nextrec move.l  a5,a1
        move.w  p.cmp+2(a5),d1  ; reverse ?? (we have to get "first" record)
        btst    #c..rvrs,d1
        beq.s   next
        xjsr    cod_PREV        ; try previous record
        bne.s   codend
        bra     loop
next    xjsr    cod_NEXT        ; try next record
        bne.s   codend
        bra     loop

setret                          ; we just have to fill d6/d7 in if asked !!
                                ; in p.rfld, p.rplc
        tst.w   p.rfld-4(a5)    ; moeten we updaten ??
        beq.s   plc
        move.l  p.rfld(a5),d1   ; address
        beq.s   plc             ; oops
        move.l  d1,a1
        move.w  d7,(a1)         ; fill in
plc     tst.w   p.rplc-4(a5)    ; moeten we updaten
        beq.s   codend
        move.l  p.rplc(a5),d1   ; address
        beq.s   plc             ; oops
        move.l  d1,a1
        move.w  d6,(a1)         ; fill in
codend  subend

; we have to search all fields with suitable type
allfld
even    equ     $fffffffe
        move.l  b_rlen(a4),d1
        move.l  b_mem(a4),a1
        tst.l   d1              ; empty record ?
        beq.s   fldend          ; yep -> ..

floop   moveq   #0,d7
        move.b  rf_id(a1),d7    ; fieldid
        mulu    #18,d7          ; offset in list
        addi.w  #f_fields,d7    ; offset in fielddata
        move.l  b_file(a4),a2   ; filedata
        move.b  0(a2,d7.w),d4   ; fieldtype
        cmp.b   d4,d5           ; fieldid ok ??
        beq.s   fallf            ; yes -> ..
        swap    d5
        cmp.b   d4,d5           ; other possible value
        bne.s   nextf           ; no, wrong type -> ...
fallf   moveq   #0,d7
        move.b  rf_id(a1),d7    ; fieldid has to be set for possible update
        jsr     (a0)            ; find value in field
        beq     setret          ; found -> return correct values

nextf   move.l  rf_len(a1),d2   ; length of this field
        addi.l  #rf_fld,d2      ; and length of field header
        addq.l  #1,d2           ; make it larger
        andi.l  #even,d2        ; and even
        sub.l   d2,d1           ; remaining length of record
        ble.s   fldend          ; we checked all fields and couldn't find it
        adda.l  d2,a1           ; start of next field
        bra.s   floop

fldend  bra     nextrec

; routines to perform the actual searching
str     subr
        regsave d1-d5/a1/a3
s.str   equ     0       ; start of string to find
s.plc   equ     4       ; start of place to find string
s.slen  equ     8       ; len of str -1
s.len   equ     10
        getssp  s.len
        moveq   #err.itnf,d0    ; assume not found
        moveq   #1,d6           ; start searching at start
        move.l  rf_len(a1),d1   ; len of field
        sub.w   d3,d1           ; nr of strings to try
        bmi.s   sdone
        lea     rf_fld(a1),a1   ; start of field
        move.l  a1,s.plc(sp)
        move.w  p.cmp+2(a5),d2  ; compare method
        subq.w  #1,d3
        move.w  d3,s.slen(sp)   ; len of str
        move.l  a3,s.str(sp)
slp     move.w  s.slen(sp),d3   ; counter with nr of letters to go
        move.l  s.str(sp),a3    ; string to find
        move.l  s.plc(sp),a1    ; place to compare with str
clp     move.b  (a1)+,d4
        move.b  (a3)+,d5
        btst    #c..case,d2     ; do we have to compare case sensitive
        bne.s   nocase          ; yes -> ..
        cmpi.b  #'a',d4
        blt.s   ecase           ; not lowercase -> ..
        cmpi.b  #'z',d4
        bgt.s   ecase           ; not lowercase -> ..
        add.b   #'A'-'a',d4     ; convert to uppercase
ecase   cmpi.b  #'a',d5
        blt.s   nocase          ; not lowercase -> ..
        cmpi.b  #'z',d5
        bgt.s   nocase          ; not lowercase -> ..
        add.b   #'A'-'a',d5     ; convert to uppercase
nocase  cmp.b   d4,d5           ; compare
        bne.s   nslp            ; oops, compare next pos
        dbf     d3,clp
        bra.s   sfound
nslp    addq.l  #1,s.plc(sp)    ; one place further in string
        addq.w  #1,d6           ; one place further
        dbf     d1,slp
        bra.s   sdone           ; oops, not found
sfound  moveq   #0,d0
sdone   subend
;
int     subr
        regsave d1/d3/a1
        moveq   #err.itnf,d0    ; assume not found
        moveq   #1,d6           ; start searching at start
        move.l  p.int(a5),d3    ; (long) word to find
        cmpi.b  #ft.short,d4    ; is this a field of shorts
        beq.s   short           ; then find a short
        move.l  rf_len(a1),d1   ; len of field
        lsr.l   #2,d1           ; nr of longs to test
        subq.l  #1,d1           ; adjust for dbf
        bmi.s   idone           ; oops, can't find it
        lea     rf_fld(a1),a1   ; actual start of field
ilp     cmp.l   (a1)+,d3        ; is this the one
        beq.s   ifound          ; yep ->
        addq.w  #1,d6           ; try next one
        dbf     d1,ilp
        bra.s   idone           ; oops, not found

short   move.l  rf_len(a1),d1   ; len of field
        lsr.l   #1,d1           ; nr of words to test
        subq.l  #1,d1           ; adjust for dbf
        bmi.s   idone           ; oops, can't find it
        lea     rf_fld(a1),a1   ; actual start of field
wlp     cmp.w   (a1)+,d3        ; is this the one
        beq.s   ifound          ; yep ->
        addq.w  #1,d6           ; try next one
        dbf     d1,wlp
        bra.s   idone           ; oops, not found
ifound  moveq   #0,d0
idone   subend
;
dbl     subr
        regsave d1/d3/a1
        moveq   #err.itnf,d0    ; assume not found
        moveq   #1,d6           ; start searching at start
        move.l  rf_len(a1),d1   ; len of field
        lsr.l   #3,d1           ; nr of doubles to test
        subq.l  #1,d1           ; adjust for dbf
        bmi.s   ddone           ; oops, can't find it
        lea     rf_fld(a1),a1   ; actual start of field
dlp     move.l  p.dbl(a5),d3
        cmp.l   (a1),d3         ; is this the one
        bne.s   dnext           ; no ->
        move.l  p.dbl+4(a5),d3
        cmp.l   4(a1),d3
        beq.s   dfound
dnext   addq.w  #1,d6           ; try next one
        addq.l  #8,a1
        dbf     d1,dlp
        bra.s   ddone           ; oops, not found
dfound  moveq   #0,d0
ddone   subend
;
        end
