; set filestatus
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
        include win1_inc_keys_ext_thg
        include win1_inc_qdos_ioa
*
; set the filestatus (0 memory based, 1 disk-based)
; needs for at least the filename to be set !!
; moving to disk saves with overwrite, with default name and device (or DATAD$)
; moving to disk implements the current record !!
; in case of errors, the file may have become empty, which can cause BIG problems
; this can be tested by comparing the record count before and after the move
; when moving to memory, the buffer is released in case of problems
; when moving to memory, if the file isn't saved afterwards, and it's reloaded
;   then the file will still be disk-based
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.stat  equ     $8      ; new status (uword)
p.name  equ     $10     ; file-name, only used when moving to disk
p.device equ    $18     ; file-device, only used when moving to disk
; errors
; itnf  buffer id invalid
; ipar  new status has to be 0 or 1
;       no file name
; any file i/o error (see save and load)
cod_SFST xsub
        regsave d1-d3/d6/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.l  b_file(a4),a3   ; fileid
        cmpi.w  #0,p.stat+2(a5) ; move to mem ??
        beq.s   mem
        cmpi.w  #1,p.stat+2(a5) ; move to disk ??
        beq.s   disk
        moveq   #err.ipar,d0    ; oops, status has to be 0 or 1
codend
        subend

; move to memory
mem     moveq   #0,d0           ; no error
        bclr    #0,f_file(a3)   ; make sure the status is set
        beq.s   codend          ; nothing to do
        xjsr    loadfile        ; and move it to memory
        bra     codend
; move to disk
disk    moveq   #0,d0           ; no error
        tst.b   f_file(a3)      ; was this memory based ?
        bne.s   codend          ; no -> nothing to do
        ; we now have to save the file
        moveq   #$1c,d1         ; we need some mem for parameter parsing
        xjsr    getmem          ; get it
        bne     codend          ; oops...
        move.l  a0,a1           ; start filling in
        move.w  #thp.ptr,0(a1)  ; bufferid passed
        move.l  a4,4(a1)        ; and given
        move.l  p.name-4(a5),8(a1)
        move.l  p.name(a5),$c(a1)
        move.l  p.device-4(a5),$10(a1)
        move.l  p.device(a5),$14(a1)
        move.w  #1,$1a(a1)      ; and overwrite
        xjsr    cod_SAVE        ; default name and device, SAVE IT !!
        bne     codend
        xjsr    relmem          ; release the mem for the parameter parsing

        ; so the file is saved and we can't lose all the data any more !!
        ; now open it again, the file and device should be ok !!
        xjsr    getjid          ; get jobid
        move.l  d0,d6
        super                   ; prevent stack from moving about
        suba.w  #70,sp          ; reserve area for filename
        xjsr    gnam            ; compose it
        move.l  d6,d1           ; we need jobid in d1
        moveq   #ioa.kexc,d3    ; exclusive use, read/write
        moveq   #ioa.open,d0
        trap    #do.ioa         ; open the file
        adda.w  #70,sp          ; clean up stack
        move.l  a0,f_chid(a3)
        tst.l   d0              ; error on opening ??
        bne.s   oops            ; oops

        ; now set this file as disk based
        moveq   #23,d1          ; file position of status
        xjsr    iof_posa        ; position file pointer
        bne.s   oops            ; error -> ..
        moveq   #1,d1           ; send new status
        xjsr    iob_sbyt
        bne.s   oops            ; error -> ..
        ; now release all data in the file, for security's sake
        move.l  f_area(a3),d1   ; place in list of areas
        beq.s   rlp_e            ; no records to release -> ..
rlp_1   move.l  d1,a5
        moveq   #99,d7          ; nr of linkages to run through
        lea     4(a5),a4        ; first record linkage
rlp_2   cmpi.l  #-1,rl_id(a4)   ; linkage used ??
        beq.s   rlp_3

        ; release it
        move.l  rl_pos(a4),a0   ; record position
        xjsr    relmem

rlp_3   adda.w  #rl.len,a4      ; start of next linkage
        dbf     d7,rlp_2

        move.l  (a5),d1         ; next area ??
        bne     rlp_1           ; if there is one
rlp_e
        rellist f_area(a3)
        clr.l   f_top(a3)
        clr.l   f_free(a3)
        clr.l   f_count(a3)     ; and we removed all records
        ; and load this file disk-based
        move.l  f_chid(a3),a0   ; we need the channel id
        xjsr    loaddisk
oops    user                    ; back to user mode
        bra     codend
;
        end
