; routines to navigate through the file
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
*
; go to the NEXT editable record
; does nothing if this record has never been implemented
; parameters
p.id    equ     $4      ; bufferid or indexid (long word, optional)
; errors
; itnf  buffer- or indexid invalid
;       no next record found
; imem  insufficient memory
cod_NEXT xsub
        regsave d1/d6/d7/a1-a4
        moveq   #1,d6           ; take next record
        bsr     get_a4          ; on return a4 will contain the indexid
                                ; or bufferid if no index given or default
        move.l  a4,d7           ; have we got an id ??
        beq.s   nexte           ; no -> return (d0 will we err.itnf)
        cmpi.l  #' ind',i_flag+10(a4)   ; is it an index id
        beq.s   nexti           ; search through index
        tst.b   b_new(a4)       ; is this a new record ??
        bne.s   nexte           ; yes -> do nothing
        move.l  b_id(a4),d7     ; current recordid
        bsr.s   NEXT
        bra.s   nexte
nexti   move.l  i_buffer(a4),a3
        tst.b   b_new(a3)       ; is this a new record ??
        bne.s   nexte           ; yes -> do nothing
        move.l  b_id(a3),d7     ; current recordid
        ; we need an empty index linkage
        move.l  a4,a2
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   ni_free         ; yes -> ...
        xjsr    getifree        ; get free index linkages
ni_free move.l  i_free(a2),a1   ; get empty linkage
        exg     a3,a4
        xjsr    fillil          ; fill in index linkage
        exg     a3,a4
        bsr.s   NEXT
        move.l  i_free(a2),a1
        move.l  #-1,il_id(a1)
nexte   subend

; get next record, based on recrodid in buffer
; d7 recordid!!, for index i_free(iid) has to be filled in appropiatly
; d6 nr of records we have to skip +1 (i.e. 1 for next record)
NEXT    subr
        regsave d1/d2/d4-d7/a0-a5
        moveq   #err.itnf,d0    ; assume we can't fing record
        cmpi.l  #' ind',i_flag+10(a4)   ; is it an index id
        beq.s   n_index         ; search through index
        move.l  b_file(a4),a3   ; fileid
nb_nxt  suba.l  a2,a2           ; assume we can't find a next record
        mutex                   ; we need this as we will move through the file-tree
        move.l  f_top(a3),d2    ; start of file
        beq     n_end           ; oops, not found
nb_loop move.l  d2,a1           ; start of record linkage
        cmp.l   rl_id(a1),d7    ; is this the one ?
        beq.s   n_ahum          ; -> found
        bcc.s   nb_right        ; take right node
        ; left node
        move.l  a1,a2           ; this will be the NEXT one
        move.l  rl_left(a1),d2  ; next one (smaller id)
        bne.s   nb_loop         ; if it exists
        bra.s   n_ahum          ; or we won't be able to find it
nb_right; right node
        move.l  rl_right(a1),d2 ; next one (larger id)
        bne.s   nb_loop         ; if it exists

n_ahum  endmutex                ; a2 now contains linkage with NEXT or 0
        move.l  rl_right(a1),d2 ; is this the NEXT
        beq.s   nb_fn           ; no -> ..
nb_nxr  move.l  d2,a2           ; this is the NEXT
        move.l  rl_left(a2),d2
        bne.s   nb_nxr
        bra.s   nb_nx
nb_fn   move.l  a2,d1           ; set ??
        beq     n_end           ; there is no NEXT record
nb_nx   move.l  rl_id(a2),d7    ; new current id

        subq.l  #1,d6           ; is this the record we need
        bgt     nb_nxt          ; no -> take next one

        tst.b   rl_edit(a2)     ; is this one edited ?
        bne.s   nb_nxt          ; take NEXT record

        move.l  d7,d1           ; recordid
        xjsr    GREC            ; get record
        bra     n_end

n_index ; we have to find it in the index
        moveq   #0,d4
        moveq   #0,d5
        move.l  i_buffer(a4),a2 ; get the bufferid for this index
        exg     a2,a4           ; indexid in a2, bufferid in a4
ni_nxt  move.l  i_free(a2),a1   ; get empty linkage
        suba.l  a3,a3           ; assume we can't find a next record
        move.l  i_top(a2),d2    ; start of index
        beq.s   n_end           ; oops, not found
ni_loop move.l  d2,a0           ; start of record linkage
        move.w  i_len(a2),d1    ; nr of words to compare
        subq.w  #1,d1
        bmi.s   ni_rid
        lea     il_index(a0),a4
        lea     il_index(a1),a5
ni_cl   move.w  (a4)+,d4        ; compare a word
        move.w  (a5)+,d5
        cmp.l   d4,d5
        bgt.s   ni_right        ; link to the right
        blt.s   ni_left         ; link to the left
        dbf     d1,ni_cl        ; or compare next
ni_rid                          ; if all equal, order of recordid
        ; consider the order of the recordid's
        move.l  il_id(a1),d1    ; id of new record
        cmp.l   il_id(a0),d1    ; compare with top of tree
        bgt.s   ni_right        ; link to the right
        beq.s   ni_ahum         ; equal -> found
ni_left ; left node
        move.l  a0,a3           ; this will be the NEXT one
        move.l  il_left(a0),d2  ; next one (smaller id)
        bne.s   ni_loop         ; if it exists
        bra.s   ni_ahum         ; or we won't be able to find it
ni_right; right node
        move.l  il_right(a0),d2 ; next one (larger id)
        bne.s   ni_loop         ; if it exists

ni_ahum move.l  rl_right(a0),d2 ; is this the NEXT
        beq.s   ni_fn           ; no -> ..
ni_nxr  move.l  d2,a3           ; is this the NEXT
        move.l  rl_left(a3),d2
        bne.s   ni_nxr
        bra.s   ni_nx
ni_fn   move.l  a3,d1           ; set ??
        beq.s   n_end           ; there is no NEXT record
ni_nx   move.l  il_id(a3),d7    ; new current id
        move.l  il_id(a3),il_id(a1)
        lea     il_index(a1),a4 ; prepare index linkage if we need the NEXT
        lea     il_index(a3),a5
        move.w  i_len(a2),d1
        subq.w  #1,d1
        bmi.s   ni_rid2
ni_cpil move.w  (a5)+,(a4)+
        dbf     d1,ni_cpil
ni_rid2
        subq.l  #1,d6           ; is this the record we need
        bgt     ni_nxt          ; no -> take next one

        move.l  d7,d1           ; recordid
        move.l  i_buffer(a2),a4 ; we need the bufferid
        xjsr    GREC            ; get record
        bne     ni_nxt          ; oops, problem, we need the NEXT
n_end   subend

; get indexid or bufferid in a4 (indexid preferred)
get_a4  xsub
        regsave a3
        suba.l  a4,a4           ; clear a4 in case we can't find anything suitable
        tst.w   p.id-4(a1)      ; is the parameter given
        bne.s   a_nodef         ; yep -> don't use default
        xjsr    getbuff         ; default buffer for this job in d0
        move.l  d0,a3           ; bufferid in a3 (temporary)
        xjsr    testbid         ; now, is it a valid buffer ?
        bne.s   a_end           ; no -> don't do anything
a_buff  tst.l   b_dindex(a3)    ; is there a default index
        beq.s   a_a3            ; no, return total nr of records
        move.l  b_dindex(a3),d0 ; indexid
        xjsr    testiid         ; indexid valid
        bne.s   a_a3
        move.l  b_dindex(a3),a4 ; this is the one we need
        bra.s   a_end           ; done
a_nodef move.l  p.id(a1),d0     ; get the given id
        move.l  d0,a3
        xjsr    testbid         ; is it a buffer id
        beq.s   a_buff          ; process bufferid
                                ; oops, can it be an index id
        move.l  a3,d0
        xjsr    testiid         ; check it out
        bne.s   a_end           ; who the hell did the parameter parsing ?
a_a3    move.l  a3,a4
a_end   subend
*
; go to the FIRST editable record
; parameters
;p.id    equ     $4      ; bufferid or indexid (long word, optional)
; errors
; itnf  buffer- or indexid invalid
; imem  insufficient memory
cod_FRST xsub
        regsave d1/d7/a0-a5
        bsr     get_a4          ; on return a4 will contain the indexid
                                ; or bufferid if no index given or default
        move.l  a4,d7           ; have we got an id ??
        beq     frste           ; no -> return (d0 will we err.itnf)
        cmpi.l  #' ind',i_flag+10(a4)   ; is it an index id
        beq.s   frsti           ; search through index
        ; get most leftward linkage
        ; editable -> ok, else -> next
        move.l  b_file(a4),a3
        mutex
        move.l  f_top(a3),d1
        beq.s   frst_u
fb_lp   move.l  d1,a1           ; first
        move.l  rl_left(a1),d1  ; is there an earlier one
        bne.s   fb_lp           ; get it
        endmutex
        move.l  rl_id(a1),d1    ; recordid
        xjsr    GREC            ; get record
        beq.s   frste           ; ok -> done
        move.l  d1,d7
        bsr     NEXT            ; we need the NEXT
        bra.s   frste
frst_u  endmutex                ; go back to user and finish
        bra.s   frste

frsti   ; get most leftward linkage
        ; editable -> ok, else -> next
        move.l  i_top(a4),d1
        beq.s   frste
fi_lp   move.l  d1,a1           ; first
        move.l  il_left(a1),d1  ; is there an earlier one
        bne.s   fi_lp           ; get it
        move.l  il_id(a1),d1    ; recordid
        move.l  i_buffer(a4),a3
        exg     a3,a4
        xjsr    GREC            ; get record
        beq.s   frste           ; ok -> done
        move.l  d1,d7           ; recordid
        exg     a3,a4
        ; we need an empty index linkage
        move.l  a4,a2
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   fi_free         ; yes -> ...
        xjsr    getifree        ; get free index linkages
fi_free move.l  i_free(a2),a0   ; get empty linkage
        move.l  il_id(a1),il_id(a0) ; fill it in with FIRST record
        lea     il_index(a1),a1 ; prepare index linkage if we need the NEXT
        lea     il_index(a0),a0
        move.w  i_len(a2),d1
        subq.w  #1,d1
        bmi.s   fi_rid
fi_cpil move.w  (a1)+,(a0)+
        dbf     d1,fi_cpil
fi_rid  bsr     NEXT
        move.l  i_free(a2),a1
        move.l  #-1,il_id(a1)
frste   subend
*
; go to the PREVious editable record
; does nothing if this record has never been implemented
; parameters
;p.id    equ     $4      ; bufferid or indexid (long word, optional)
; errors
; itnf  buffer- or indexid invalid
;       no previous record found
; imem  insufficient memory
cod_PREV xsub
        regsave d1/d6/d7/a1-a4
        moveq   #1,d6           ; take previous record
        bsr     get_a4          ; on return a4 will contain the indexid
                                ; or bufferid if no index given or default
        move.l  a4,d7           ; have we got an id ??
        beq.s   preve           ; no -> return (d0 will we err.itnf)
        cmpi.l  #' ind',i_flag+10(a4)   ; is it an index id
        beq.s   previ           ; search through index
        tst.b   b_new(a4)       ; is this a new record ??
        bne.s   preve           ; yes -> do nothing
        move.l  b_id(a4),d7     ; current recordid
        bsr.s   PREV
        bra.s   preve
previ   move.l  i_buffer(a4),a3
        tst.b   b_new(a3)       ; is this a new record ??
        bne.s   preve           ; yes -> do nothing
        move.l  b_id(a3),d7     ; current recordid
        ; we need an empty index linkage
        move.l  a4,a2
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   pi_free         ; yes -> ...
        xjsr    getifree        ; get free index linkages
pi_free move.l  i_free(a2),a1   ; get empty linkage
        exg     a3,a4
        xjsr    fillil          ; fill in index linkage
        exg     a3,a4
        bsr.s   PREV
        move.l  i_free(a2),a1
        move.l  #-1,il_id(a1)
preve   subend

; get next record, based on recordid in buffer
; d7 recordid!!, for index i_free(iid) has to be filled in appropiatly
PREV    subr
        regsave d1/d2/d4-d7/a0-a5
        moveq   #err.itnf,d0    ; assume no previous record found
        cmpi.l  #' ind',i_flag+10(a4)   ; is it an index id
        beq.s   p_index         ; search through index
        move.l  b_file(a4),a3   ; fileid
pb_nxt  suba.l  a2,a2           ; assume we can't find a next record
        mutex                   ; we need this as we will move through the file-tree
        move.l  f_top(a3),d2    ; start of file
        beq     p_end           ; oops, not found
pb_loop move.l  d2,a1           ; start of record linkage
        cmp.l   rl_id(a1),d7    ; is this the one ?
        beq.s   p_ahum          ; -> found
        bcc.s   pb_right        ; take right node
        ; left node
        move.l  rl_left(a1),d2  ; next one (smaller id)
        bne.s   pb_loop         ; if it exists
        bra.s   p_ahum          ; or we won't be able to find it
pb_right; right node
        move.l  a1,a2           ; this will be the PREV one
        move.l  rl_right(a1),d2 ; next one (larger id)
        bne.s   pb_loop         ; if it exists

p_ahum  endmutex                ; a2 now contains linkage with NEXT or 0
        move.l  rl_left(a1),d2  ; is this the NEXT
        beq.s   pb_fn           ; no -> ..
pb_nxr  move.l  d2,a2           ; this is the NEXT
        move.l  rl_right(a2),d2
        bne.s   pb_nxr
        bra.s   pb_nx
pb_fn   move.l  a2,d1           ; set ??
        beq     p_end           ; there is no NEXT record
pb_nx   move.l  rl_id(a2),d7    ; new current id

        subq.l  #1,d6           ; is this the record we need
        bgt     pb_nxt          ; no -> take next one

        tst.b   rl_edit(a2)     ; is this one edited ?
        bne.s   pb_nxt          ; take NEXT record

        move.l  d7,d1           ; recordid
        xjsr    GREC            ; get record
        bra     p_end

p_index ; we have to find it in the index
        moveq   #0,d4
        moveq   #0,d5
        move.l  i_buffer(a4),a2 ; get the bufferid for this index
        exg     a2,a4           ; indexid in a2, bufferid in a4
pi_nxt  move.l  i_free(a2),a1   ; get empty linkage
        suba.l  a3,a3           ; assume we can't find a next record
        move.l  i_top(a2),d2    ; start of index
        beq.s   p_end           ; oops, not found
pi_loop move.l  d2,a0           ; start of record linkage
        move.w  i_len(a2),d1    ; nr of words to compare
        subq.w  #1,d1
        bmi.s   pi_rid
        lea     il_index(a0),a4
        lea     il_index(a1),a5
pi_cl   move.w  (a4)+,d4        ; compare a word
        move.w  (a5)+,d5
        cmp.l   d4,d5
        bgt.s   pi_right        ; link to the right
        blt.s   pi_left         ; link to the left
        dbf     d1,pi_cl        ; or compare next
pi_rid                          ; if all equal, order of recordid
        ; consider the order of the recordid's
        move.l  il_id(a1),d1    ; id of new record
        cmp.l   il_id(a0),d1    ; compare with top of tree
        bgt.s   pi_right        ; link to the right
        beq.s   pi_ahum         ; equal -> found
pi_left ; left node
        move.l  il_left(a0),d2  ; next one (smaller id)
        bne.s   pi_loop         ; if it exists
        bra.s   pi_ahum         ; or we won't be able to find it
pi_right; right node
        move.l  a0,a3           ; this will be the PREV one
        move.l  il_right(a0),d2 ; next one (larger id)
        bne.s   pi_loop         ; if it exists

pi_ahum move.l  rl_left(a0),d2  ; is this the NEXT
        beq.s   pi_fn           ; no -> ..
pi_nxr  move.l  d2,a3           ; is this the NEXT
        move.l  rl_right(a3),d2
        bne.s   pi_nxr
        bra.s   pi_nx
pi_fn   move.l  a3,d1           ; set ??
        beq.s   p_end           ; there is no NEXT record
pi_nx   move.l  il_id(a3),d7    ; new current id
        move.l  il_id(a3),il_id(a1)
        lea     il_index(a1),a4 ; prepare index linkage if we need the NEXT
        lea     il_index(a3),a5
        move.w  i_len(a2),d1
        subq.w  #1,d1
        bmi.s   pi_rid2
pi_cpil move.w  (a5)+,(a4)+
        dbf     d1,pi_cpil
pi_rid2
        subq.l  #1,d6           ; is this the record we need
        bgt     pi_nxt          ; no -> take next one

        move.l  d7,d1           ; recordid
        move.l  i_buffer(a2),a4 ; we need the bufferid
        xjsr    GREC            ; get record
        bne     pi_nxt          ; oops, problem, we need the NEXT
p_end   subend
*
; go to the LAST editable record
; parameters
;p.id    equ     $4      ; bufferid or indexid (long word, optional)
; errors
; itnf  buffer- or indexid invalid
; imem  insufficient memory
cod_LAST xsub
        regsave d1/d7/a0-a5
        bsr     get_a4          ; on return a4 will contain the indexid
                                ; or bufferid if no index given or default
        move.l  a4,d7           ; have we got an id ??
        beq     laste           ; no -> return (d0 will we err.itnf)
        cmpi.l  #' ind',i_flag+10(a4)   ; is it an index id
        beq.s   lasti           ; search through index
        ; get most leftward linkage
        ; editable -> ok, else -> next
        move.l  b_file(a4),a3
        mutex
        move.l  f_top(a3),d1
        beq.s   last_u
lb_lp   move.l  d1,a1           ; first
        move.l  rl_right(a1),d1 ; is there an earlier one
        bne.s   lb_lp           ; get it
        endmutex
        move.l  rl_id(a1),d1    ; recordid
        xjsr    GREC            ; get record
        beq.s   laste           ; ok -> done
        move.l  d1,d7
        bsr     PREV            ; we need the NEXT
        bra.s   laste
last_u  endmutex                ; go back to user and finish
        bra.s   laste

lasti   ; get most leftward linkage
        ; editable -> ok, else -> next
        move.l  i_top(a4),d1
        beq.s   laste
li_lp   move.l  d1,a1           ; first
        move.l  il_right(a1),d1 ; is there an earlier one
        bne.s   li_lp           ; get it
        move.l  il_id(a1),d1    ; recordid
        move.l  i_buffer(a4),a3
        exg     a3,a4
        xjsr    GREC            ; get record
        beq.s   laste           ; ok -> done
        move.l  d1,d7           ; recordid
        exg     a3,a4
        ; we need an empty index linkage
        move.l  a4,a2
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   li_free         ; yes -> ...
        xjsr    getifree        ; get free index linkages
li_free move.l  i_free(a2),a0   ; get empty linkage
        move.l  il_id(a1),il_id(a0) ; fill it in with FIRST record
        lea     il_index(a1),a1 ; prepare index linkage if we need the NEXT
        lea     il_index(a0),a0
        move.w  i_len(a2),d1
        subq.w  #1,d1
        bmi.s   li_rid
li_cpil move.w  (a1)+,(a0)+
        dbf     d1,li_cpil
li_rid  bsr     PREV
        move.l  i_free(a2),a1
        move.l  #-1,il_id(a1)
laste   subend
*
; go FORWard in the file by a given no of records
; the first editable record starting from that one will be the current
; does nothing if this record has never been implemented
; parameters
;p.id    equ     $4      ; bufferid or indexid (long word, optional)
p.skip  equ     $8      ; forward reference (1=next, is smaller, you get next)
; errors
; itnf  buffer- or indexid invalid
;       no next record found
; imem  insufficient memory
cod_FORW xsub
        regsave d1/d6/d7/a1-a4
        move.l  p.skip(a1),d6   ; nr of records to skip
        bsr     get_a4          ; on return a4 will contain the indexid
                                ; or bufferid if no index given or default
        move.l  a4,d7           ; have we got an id ??
        beq.s   forwe           ; no -> return (d0 will we err.itnf)
        cmpi.l  #' ind',i_flag+10(a4)   ; is it an index id
        beq.s   forwi           ; search through index
        tst.b   b_new(a4)       ; is this a new record ??
        bne.s   forwe           ; yes -> do nothing
        move.l  b_id(a4),d7     ; current recordid
        bsr     NEXT
        bra.s   forwe
forwi   move.l  i_buffer(a4),a3
        tst.b   b_new(a3)       ; is this a new record ??
        bne.s   forwe           ; yes -> do nothing
        move.l  b_id(a3),d7     ; current recordid
        ; we need an empty index linkage
        move.l  a4,a2
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   oi_free         ; yes -> ...
        xjsr    getifree        ; get free index linkages
oi_free move.l  i_free(a2),a1   ; get empty linkage
        exg     a3,a4
        xjsr    fillil          ; fill in index linkage
        exg     a3,a4
        bsr     NEXT
        move.l  i_free(a2),a1
        move.l  #-1,il_id(a1)
forwe   subend
*
; go BaCKWard in the file by a given no of records
; the first editable record starting from that one will be the current
; does nothing if this record has never been implemented
; parameters
;p.id    equ     $4      ; bufferid or indexid (long word, optional)
;p.skip  equ     $8      ; forward reference (1=prev, is smaller, you get prev)
; errors
; itnf  buffer- or indexid invalid
;       no previous record found
; imem  insufficient memory
cod_BCKW xsub
        regsave d1/d6/d7/a1-a4
        move.l  p.skip(a1),d6   ; no of records to skip
        bsr     get_a4          ; on return a4 will contain the indexid
                                ; or bufferid if no index given or default
        move.l  a4,d7           ; have we got an id ??
        beq.s   bckwe           ; no -> return (d0 will we err.itnf)
        cmpi.l  #' ind',i_flag+10(a4)   ; is it an index id
        beq.s   bckwi           ; search through index
        tst.b   b_new(a4)       ; is this a new record ??
        bne.s   bckwe           ; yes -> do nothing
        move.l  b_id(a4),d7     ; current recordid
        bsr     PREV
        bra.s   bckwe
bckwi   move.l  i_buffer(a4),a3
        tst.b   b_new(a3)       ; is this a new record ??
        bne.s   bckwe           ; yes -> do nothing
        move.l  b_id(a3),d7     ; current recordid
        ; we need an empty index linkage
        move.l  a4,a2
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   bi_free         ; yes -> ...
        xjsr    getifree        ; get free index linkages
bi_free move.l  i_free(a2),a1   ; get empty linkage
        exg     a3,a4
        xjsr    fillil          ; fill in index linkage
        exg     a3,a4
        bsr     PREV
        move.l  i_free(a2),a1
        move.l  #-1,il_id(a1)
bckwe   subend
;
        end
